//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private ExtTS[] cacheExtTS = null;

        private static ExtTS checkExtTS = new ExtTS();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public ExtTS ExtTS(Color ask_above_back, Color ask_above_fore, Color at_ask_back, Color at_ask_fore, Color at_bid_back, Color at_bid_fore, Color below_bid_back, Color below_bid_fore, Color between_back, Color between_fore, Color block_alert, int block_size, string fname, Font fnt, int num, bool show_grid, int size, int size_union3, bool sound_alert, int sound_alert_size, int union_by_grab, bool union_by_pd, bool union_by_pdt, UnionType utype, bool v2)
        {
            return ExtTS(Input, ask_above_back, ask_above_fore, at_ask_back, at_ask_fore, at_bid_back, at_bid_fore, below_bid_back, below_bid_fore, between_back, between_fore, block_alert, block_size, fname, fnt, num, show_grid, size, size_union3, sound_alert, sound_alert_size, union_by_grab, union_by_pd, union_by_pdt, utype, v2);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public ExtTS ExtTS(Data.IDataSeries input, Color ask_above_back, Color ask_above_fore, Color at_ask_back, Color at_ask_fore, Color at_bid_back, Color at_bid_fore, Color below_bid_back, Color below_bid_fore, Color between_back, Color between_fore, Color block_alert, int block_size, string fname, Font fnt, int num, bool show_grid, int size, int size_union3, bool sound_alert, int sound_alert_size, int union_by_grab, bool union_by_pd, bool union_by_pdt, UnionType utype, bool v2)
        {
            if (cacheExtTS != null)
                for (int idx = 0; idx < cacheExtTS.Length; idx++)
                    if (cacheExtTS[idx].Ask_above_back == ask_above_back && cacheExtTS[idx].Ask_above_fore == ask_above_fore && cacheExtTS[idx].At_ask_back == at_ask_back && cacheExtTS[idx].At_ask_fore == at_ask_fore && cacheExtTS[idx].At_bid_back == at_bid_back && cacheExtTS[idx].At_bid_fore == at_bid_fore && cacheExtTS[idx].Below_bid_back == below_bid_back && cacheExtTS[idx].Below_bid_fore == below_bid_fore && cacheExtTS[idx].Between_back == between_back && cacheExtTS[idx].Between_fore == between_fore && cacheExtTS[idx].Block_alert == block_alert && cacheExtTS[idx].Block_size == block_size && cacheExtTS[idx].Fname == fname && cacheExtTS[idx].Fnt == fnt && cacheExtTS[idx].Num == num && cacheExtTS[idx].Show_grid == show_grid && cacheExtTS[idx].Size == size && cacheExtTS[idx].Size_union3 == size_union3 && cacheExtTS[idx].Sound_alert == sound_alert && cacheExtTS[idx].Sound_alert_size == sound_alert_size && cacheExtTS[idx].Union_by_grab == union_by_grab && cacheExtTS[idx].Union_by_pd == union_by_pd && cacheExtTS[idx].Union_by_pdt == union_by_pdt && cacheExtTS[idx].Utype == utype && cacheExtTS[idx].V2 == v2 && cacheExtTS[idx].EqualsInput(input))
                        return cacheExtTS[idx];

            lock (checkExtTS)
            {
                checkExtTS.Ask_above_back = ask_above_back;
                ask_above_back = checkExtTS.Ask_above_back;
                checkExtTS.Ask_above_fore = ask_above_fore;
                ask_above_fore = checkExtTS.Ask_above_fore;
                checkExtTS.At_ask_back = at_ask_back;
                at_ask_back = checkExtTS.At_ask_back;
                checkExtTS.At_ask_fore = at_ask_fore;
                at_ask_fore = checkExtTS.At_ask_fore;
                checkExtTS.At_bid_back = at_bid_back;
                at_bid_back = checkExtTS.At_bid_back;
                checkExtTS.At_bid_fore = at_bid_fore;
                at_bid_fore = checkExtTS.At_bid_fore;
                checkExtTS.Below_bid_back = below_bid_back;
                below_bid_back = checkExtTS.Below_bid_back;
                checkExtTS.Below_bid_fore = below_bid_fore;
                below_bid_fore = checkExtTS.Below_bid_fore;
                checkExtTS.Between_back = between_back;
                between_back = checkExtTS.Between_back;
                checkExtTS.Between_fore = between_fore;
                between_fore = checkExtTS.Between_fore;
                checkExtTS.Block_alert = block_alert;
                block_alert = checkExtTS.Block_alert;
                checkExtTS.Block_size = block_size;
                block_size = checkExtTS.Block_size;
                checkExtTS.Fname = fname;
                fname = checkExtTS.Fname;
                checkExtTS.Fnt = fnt;
                fnt = checkExtTS.Fnt;
                checkExtTS.Num = num;
                num = checkExtTS.Num;
                checkExtTS.Show_grid = show_grid;
                show_grid = checkExtTS.Show_grid;
                checkExtTS.Size = size;
                size = checkExtTS.Size;
                checkExtTS.Size_union3 = size_union3;
                size_union3 = checkExtTS.Size_union3;
                checkExtTS.Sound_alert = sound_alert;
                sound_alert = checkExtTS.Sound_alert;
                checkExtTS.Sound_alert_size = sound_alert_size;
                sound_alert_size = checkExtTS.Sound_alert_size;
                checkExtTS.Union_by_grab = union_by_grab;
                union_by_grab = checkExtTS.Union_by_grab;
                checkExtTS.Union_by_pd = union_by_pd;
                union_by_pd = checkExtTS.Union_by_pd;
                checkExtTS.Union_by_pdt = union_by_pdt;
                union_by_pdt = checkExtTS.Union_by_pdt;
                checkExtTS.Utype = utype;
                utype = checkExtTS.Utype;
                checkExtTS.V2 = v2;
                v2 = checkExtTS.V2;

                if (cacheExtTS != null)
                    for (int idx = 0; idx < cacheExtTS.Length; idx++)
                        if (cacheExtTS[idx].Ask_above_back == ask_above_back && cacheExtTS[idx].Ask_above_fore == ask_above_fore && cacheExtTS[idx].At_ask_back == at_ask_back && cacheExtTS[idx].At_ask_fore == at_ask_fore && cacheExtTS[idx].At_bid_back == at_bid_back && cacheExtTS[idx].At_bid_fore == at_bid_fore && cacheExtTS[idx].Below_bid_back == below_bid_back && cacheExtTS[idx].Below_bid_fore == below_bid_fore && cacheExtTS[idx].Between_back == between_back && cacheExtTS[idx].Between_fore == between_fore && cacheExtTS[idx].Block_alert == block_alert && cacheExtTS[idx].Block_size == block_size && cacheExtTS[idx].Fname == fname && cacheExtTS[idx].Fnt == fnt && cacheExtTS[idx].Num == num && cacheExtTS[idx].Show_grid == show_grid && cacheExtTS[idx].Size == size && cacheExtTS[idx].Size_union3 == size_union3 && cacheExtTS[idx].Sound_alert == sound_alert && cacheExtTS[idx].Sound_alert_size == sound_alert_size && cacheExtTS[idx].Union_by_grab == union_by_grab && cacheExtTS[idx].Union_by_pd == union_by_pd && cacheExtTS[idx].Union_by_pdt == union_by_pdt && cacheExtTS[idx].Utype == utype && cacheExtTS[idx].V2 == v2 && cacheExtTS[idx].EqualsInput(input))
                            return cacheExtTS[idx];

                ExtTS indicator = new ExtTS();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Ask_above_back = ask_above_back;
                indicator.Ask_above_fore = ask_above_fore;
                indicator.At_ask_back = at_ask_back;
                indicator.At_ask_fore = at_ask_fore;
                indicator.At_bid_back = at_bid_back;
                indicator.At_bid_fore = at_bid_fore;
                indicator.Below_bid_back = below_bid_back;
                indicator.Below_bid_fore = below_bid_fore;
                indicator.Between_back = between_back;
                indicator.Between_fore = between_fore;
                indicator.Block_alert = block_alert;
                indicator.Block_size = block_size;
                indicator.Fname = fname;
                indicator.Fnt = fnt;
                indicator.Num = num;
                indicator.Show_grid = show_grid;
                indicator.Size = size;
                indicator.Size_union3 = size_union3;
                indicator.Sound_alert = sound_alert;
                indicator.Sound_alert_size = sound_alert_size;
                indicator.Union_by_grab = union_by_grab;
                indicator.Union_by_pd = union_by_pd;
                indicator.Union_by_pdt = union_by_pdt;
                indicator.Utype = utype;
                indicator.V2 = v2;
                Indicators.Add(indicator);
                indicator.SetUp();

                ExtTS[] tmp = new ExtTS[cacheExtTS == null ? 1 : cacheExtTS.Length + 1];
                if (cacheExtTS != null)
                    cacheExtTS.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheExtTS = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ExtTS ExtTS(Color ask_above_back, Color ask_above_fore, Color at_ask_back, Color at_ask_fore, Color at_bid_back, Color at_bid_fore, Color below_bid_back, Color below_bid_fore, Color between_back, Color between_fore, Color block_alert, int block_size, string fname, Font fnt, int num, bool show_grid, int size, int size_union3, bool sound_alert, int sound_alert_size, int union_by_grab, bool union_by_pd, bool union_by_pdt, UnionType utype, bool v2)
        {
            return _indicator.ExtTS(Input, ask_above_back, ask_above_fore, at_ask_back, at_ask_fore, at_bid_back, at_bid_fore, below_bid_back, below_bid_fore, between_back, between_fore, block_alert, block_size, fname, fnt, num, show_grid, size, size_union3, sound_alert, sound_alert_size, union_by_grab, union_by_pd, union_by_pdt, utype, v2);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.ExtTS ExtTS(Data.IDataSeries input, Color ask_above_back, Color ask_above_fore, Color at_ask_back, Color at_ask_fore, Color at_bid_back, Color at_bid_fore, Color below_bid_back, Color below_bid_fore, Color between_back, Color between_fore, Color block_alert, int block_size, string fname, Font fnt, int num, bool show_grid, int size, int size_union3, bool sound_alert, int sound_alert_size, int union_by_grab, bool union_by_pd, bool union_by_pdt, UnionType utype, bool v2)
        {
            return _indicator.ExtTS(input, ask_above_back, ask_above_fore, at_ask_back, at_ask_fore, at_bid_back, at_bid_fore, below_bid_back, below_bid_fore, between_back, between_fore, block_alert, block_size, fname, fnt, num, show_grid, size, size_union3, sound_alert, sound_alert_size, union_by_grab, union_by_pd, union_by_pdt, utype, v2);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ExtTS ExtTS(Color ask_above_back, Color ask_above_fore, Color at_ask_back, Color at_ask_fore, Color at_bid_back, Color at_bid_fore, Color below_bid_back, Color below_bid_fore, Color between_back, Color between_fore, Color block_alert, int block_size, string fname, Font fnt, int num, bool show_grid, int size, int size_union3, bool sound_alert, int sound_alert_size, int union_by_grab, bool union_by_pd, bool union_by_pdt, UnionType utype, bool v2)
        {
            return _indicator.ExtTS(Input, ask_above_back, ask_above_fore, at_ask_back, at_ask_fore, at_bid_back, at_bid_fore, below_bid_back, below_bid_fore, between_back, between_fore, block_alert, block_size, fname, fnt, num, show_grid, size, size_union3, sound_alert, sound_alert_size, union_by_grab, union_by_pd, union_by_pdt, utype, v2);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.ExtTS ExtTS(Data.IDataSeries input, Color ask_above_back, Color ask_above_fore, Color at_ask_back, Color at_ask_fore, Color at_bid_back, Color at_bid_fore, Color below_bid_back, Color below_bid_fore, Color between_back, Color between_fore, Color block_alert, int block_size, string fname, Font fnt, int num, bool show_grid, int size, int size_union3, bool sound_alert, int sound_alert_size, int union_by_grab, bool union_by_pd, bool union_by_pdt, UnionType utype, bool v2)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ExtTS(input, ask_above_back, ask_above_fore, at_ask_back, at_ask_fore, at_bid_back, at_bid_fore, below_bid_back, below_bid_fore, between_back, between_fore, block_alert, block_size, fname, fnt, num, show_grid, size, size_union3, sound_alert, sound_alert_size, union_by_grab, union_by_pd, union_by_pdt, utype, v2);
        }
    }
}
#endregion
